- name: Play to Add new vPC
  hosts: all
  connection: local
  gather_facts: no
  vars: 
    apic_login: &apic_login
      host: "{{ apic_host }}"
      username: "{{ user_var }}"
      password: "{{ user_pass }}"
      validate_certs: no
      use_proxy: False   
      use_ssl: True  
      state: present
    delay_var: 0.1

  tasks:

    - name: Add vPC
      block:
    
        - name: Add interface policy leaf policy group
          aci_interface_policy_leaf_policy_group:
            <<: *apic_login
            lag_type: node
            policy_group: "vpc.L{{ int.leaf1_id }}.L{{ int.leaf2_id }}.1.{{ int.interface_id }}-intpolgrp"
            aep: taxud-aaep
            cdp_policy: cdp.on-intpol
            lldp_policy: lldp.on-intpol
            link_level_policy: autonego-intpol
            mcp_policy: mcp.off-intpol 
            stp_interface_policy: bpdu.guard-intpol
            port_channel_policy: pc.lacp.active-intpol
          loop: "{{ awx_webhook_payload.data.local_context_data.interface_vpc_add }}"
          loop_control:
                   loop_var: int
                   label: "Adding new INTERFACE POLICY GROUP NAME: vpc.L{{ int.leaf1_id }}.L{{ int.leaf2_id }}.1.{{ int.interface_id }}-intpolgrp"
                   pause: "{{ delay_var }}"

        - name: Associate an Interface Access Port Selector to an Interface Policy Leaf Profile with a Policy Group
          aci_access_port_to_interface_policy_leaf_profile:
            <<: *apic_login
            leaf_interface_profile: "vpc.{{ int.dc }}-{{ int.env }}-L{{ int.leaf1_id }}.L{{ int.leaf2_id }}-intprof"
            access_port_selector: vpc.L{{ int.leaf1_id }}.L{{ int.leaf2_id }}.1.{{ int.interface_id }}-intsel
            interface_type: vpc
            leaf_port_blk: "vpc.L{{ int.leaf1_id }}.L{{ int.leaf2_id }}.1.{{ int.interface_id }}-intblk"
            leaf_port_blk_description: "{{ int.interface_desc }}"
            from_port: "{{ int.interface_id }}"
            to_port: "{{ int.interface_id }}"
            policy_group: "vpc.L{{ int.leaf1_id }}.L{{ int.leaf2_id }}.1.{{ int.interface_id }}-intpolgrp"
          loop: "{{ awx_webhook_payload.data.local_context_data.interface_vpc_add }}"
          loop_control:
                   loop_var: int
                   label: "Associate PORT SELECTOR NAME: vpc.L{{ int.leaf1_id }}.L{{ int.leaf2_id }}.1.{{ int.interface_id }}-intsel to INTERFACE PROFILE NAME: vpc.{{ int.dc }}-{{ int.env }}-L{{ int.leaf1_id }}.L{{ int.leaf2_id }}-intprof with POLICY GROUP NAME: vpc.L{{ int.leaf1_id }}.L{{ int.leaf2_id }}.1.{{ int.interface_id }}-intpolgrp"
                   pause: "{{ delay_var }}"
      when:
        - awx_webhook_payload.data.local_context_data.interface_vpc_add is defined
        - awx_webhook_payload.data.local_context_data.interface_vpc_add | type_debug == 'list'
        - awx_webhook_payload.data.local_context_data.interface_vpc_add | length > 0